<?php

namespace App\Http\Controllers;

use App\Authapi;
use App\Customer;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Str;

class BookingController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    public function getList(Request $request){
        $posts = 10;
        if(isset($request->page) && $request->page > 0){
            $page = (int) $request->page;
        }else{
            $page = 1;
        }
        $order = '';
        if($request->order == 'pickup'){
            $order = 'pickup_date';
        }else if($request->order == 'dropoff'){
            $order = 'dropoff_date';
        }else if($request->order == 'booking_id'){
            $order = 'id';
        }
        //dd((!isset($request->page)));
        //echo $page;
        $skip = (($page -1) * $posts);
        $count = DB::table('smtt_booking')->where(function ($query) use ($request) {
            $query->where('customer_id',$request->userid);
            if(isset($request->btype)){
                if($request->btype == 'upcoming'){
                    $query->whereIn('status',['advance_pending', 'confirm']);
                } else if($request->btype == 'ongoing'){
                    $query->whereIn('status',['ongoing']);
                } else if($request->btype == 'completed'){
                    $query->whereIn('status',['settle','unsettle','completed']);
                } else if($request->btype == 'All'){
                    $query->whereIn('status',['advance_pending', 'confirm', 'ongoing', 'settle', 'unsettle', 'completed']);
                }
            }
        })->count();
        $res = DB::table('smtt_booking')->select('id', 'pickup_location', 'pickup_date', 'pickup_time', 'dropoff_date', 'dropoff_time', 'status')->where(function ($query) use ($request) {
            $query->where('customer_id',$request->userid);
            if(isset($request->btype)){
                if($request->btype == 'upcoming'){
                    $query->whereIn('status',['advance_pending', 'confirm']);
                } else if($request->btype == 'ongoing'){
                    $query->whereIn('status',['ongoing']);
                } else if($request->btype == 'completed'){
                    $query->whereIn('status',['settle','unsettle','completed']);
                } else if($request->btype == 'All'){
                    $query->whereIn('status',['advance_pending', 'confirm', 'ongoing', 'settle', 'unsettle', 'completed']);
                }
            }
        })->orderBy($order, $request->sort)->skip($skip)->take($posts)->get();
        if(count($res->toArray()) > 0){
            return response()->json(['list' => $res->toArray(), 'total_page' => ceil($count/$posts), 'total_items' => $count, 'current_page' => $page, 'item_start' => ($skip+1), 'pageSize' => $posts]);
        }else{
            return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
        }
    }

    public function getSingle(Request $request) {
        $info = DB::table('smtt_booking')->where('id', $request->bid)->first();

        $itinerary = DB::table('smtt_booking_itinerary')->select('date', 'cities', 'night_hold')->where('booking_id',
            $request->bid)->orderBy('date', 'asc')->get();

        $bookingVehicles = DB::table('smtt_booking_vehicle')->where('booking_id',
            $request->bid)->orderBy('id', 'asc')->get();
        $exe = array();
        array_push($exe, $info->manager);
        $veh = array();
        $vehCat = array();
        foreach ($bookingVehicles as $row){
            if(!in_array($row->vehicle_id, $veh)){
                array_push($veh, $row->vehicle_id);
            }
            if(!in_array($row->vcat_id, $vehCat)){
                array_push($vehCat, $row->vcat_id);
            }
        }

        $vehicleAllocation = DB::table('smtt_booking_vehicle_management')->where('booking_id', $request->bid)
            ->orderByRaw('vehicle_count asc, sub_vehicle asc, date asc')->get();
        $vehAloo = array();
        $driver = array();
        $index = 0;
        $lKey = '';
        foreach ($vehicleAllocation as $row){
            if($row->own == 0){
                if(!in_array($row->vehicle, $veh)){
                    array_push($veh, $row->vehicle);
                }
                if(!in_array($row->v_cat, $vehCat)){
                    array_push($vehCat, $row->v_cat);
                }
                if(!in_array($row->driver, $driver)){
                    array_push($driver, $row->driver);
                }
                $key = $row->own.'_'.$row->vehicle_count.'_'.$row->sub_vehicle.'_'.$row->vehicle.'_'.$row->driver;
                if($lKey != $key.'_'.$index){
                    $index++;
                    $lKey = $key.'_'.$index;
                    $vehAloo[$lKey] = array(
                        'own' => $row->own,
                        'vehicle' => $row->vehicle,
                        'veh_cat' => $row->v_cat,
                        'driver' => $row->driver,
                        'is_cancel' => $row->is_cancel,
                        'date' => array(),
                    );
                }
                array_push($vehAloo[$lKey]['date'], $row->date);
            }else{
                $key = $row->own.'_'.$row->vehicle_count.'_'.$row->sub_vehicle;
                $key .= '_'.str_replace(' ', '', $row->vendor_vehicle);
                $key .= '_'.str_replace(' ', '', $row->vendor_driver);
                if($lKey != $key.'_'.$index){
                    $index++;
                    $lKey = $key.'_'.$index;
                    $vehAloo[$lKey] = array(
                        'own' => $row->own,
                        'vehicle' => $row->vendor_vehicle,
                        'veh_cat' => $row->vendor_vcat,
                        'driver' => $row->vendor_driver,
                        'driver_number' => $row->vendor_driver_number,
                        'is_cancel' => $row->is_cancel,
                        'date' => array(),
                    );
                }
                array_push($vehAloo[$lKey]['date'], $row->date);
            }
        }
        $vehAloo=array_values($vehAloo);

        $payments = DB::table('smtt_booking_payment')->where('booking_id', $request->bid)->where('recived', 1)->where
        ('amount', '>', 0)->orderBy('date', 'asc')->get();

        $remaining = DB::table('smtt_booking_customer_remaining')->where('booking_id', $request->bid)->first();

        $settlementDriver = DB::table('smtt_booking_settlement_driver')->where('booking_id', $request->bid)->sum('cash_collect');

        $settlementVendor = DB::table('smtt_booking_settlement_vendor')->where('booking_id', $request->bid)->sum('cash_collect');

        $bills = DB::table('smtt_booking_invoice')->select('invoice_type')->where('booking_id', $request->bid)->get();

        $invoice = $invoice_am = "";

        foreach ($bills as $row){
            if($row->invoice_type == 'booking'){
                $invoice = "https://shri-mangal-storage-qw457.s3.amazonaws.com/invoice/". md5('uploads/invoice/invoice-'
                        .$request->bid.'.pdf') . "_" .basename('uploads/invoice/invoice-'
                        .$request->bid.'.pdf');
            }else{
                $invoice_am = "https://shri-mangal-storage-qw457.s3.amazonaws.com/invoice/". md5('uploads/invoice/invoice-'
                        .$request->bid.'.pdf') . "_am_" .basename('uploads/invoice/invoice-'
                        .$request->bid.'.pdf');
            }
        }

        $vehiclesLoco =array();

        $urlLoco = "https://loconav.com/api/v3/device/all_devices?start_index=0&end_index=100";

        $resultLoco = $this->getFromCurl($urlLoco, 'SXsvzxVokErNSt2NMffh');


        //print_r($resultLoco);exit();

        foreach ($resultLoco as $row){
            $nameLoco = strtoupper(str_replace(' ','',$row->data->vehicle_number));
            $vehiclesLoco[$nameLoco] = $row->data;
            //array_push($ids,$name);
        }
        //print_r($vehiclesLoco);









        /** core values **/

        $vehicles = DB::table('smtt_vehicle_category')->select('id', 'name')->whereIn('id', $vehCat)->get();
        $vehicleCatList = array();
        foreach ($vehicles as $row){
            $vehicleCatList[$row->id] = $row;
        }

        $vehicles = DB::table('smtt_vehicles')->select('id', 'name', 'number', 'seats', 'loco_veh_id')->whereIn('id', $veh)->get();
        $vehicleList = array();
        foreach ($vehicles as $row){
            $vehicleList[$row->id] = $row;
            $nameLoco = $row->loco_veh_id;
            //echo $nameLoco;
            if(isset($vehiclesLoco[$nameLoco])){
                $vehicleList[$row->id]->share_link = $vehiclesLoco[$nameLoco]->share_link;
            }
        }

        $vehiclesDoc = DB::table('smtt_vehicle_docs')->select('vehicle_id', 'type', 'file')->whereIn('vehicle_id', $veh)->where('active', 1)
            ->get();

        $executives = DB::table('smtt_user')->select('id', 'name')->whereIn('id', $exe)->get();
        $executivesList = array();
        foreach ($executives as $row){
            $executivesList[$row->id] = $row->name;
        }

        $employees = DB::table('smtt_employees')->select('id', 'name', 'phone', 'photo')->whereIn('id', $driver)->get();
        $empList = array();
        foreach ($employees as $row){
            $empList[$row->id] = $row;
        }

        // /home/smtthost/public_html/portal353/
        // uploads/invoice/invoice-17943.pdf

        //dd($info);
        return response()->json([
            'info' => $info,
            'itinerary' => $itinerary->toArray(),
            'bookingVehicles' => $bookingVehicles->toArray(),
            'vehicleAllocation' => $vehAloo,
            'payments' => $payments,
            'cashCollect' => ($settlementDriver + $settlementVendor),
            'remaining' => $remaining,
            'invoice' => $invoice,
            'invoice_am' => $invoice_am,
            'vehicleCatList' => $vehicleCatList,
            'vehicleDocs' => $vehiclesDoc->toArray(),
            'vehicleList' => $vehicleList,
            'driverList' => $empList,
            'executivesList' => $executivesList
        ]);
    }

    private function getHappayExpenses($bid){
        $return = array(
            'fuel' => 0,
            'toll' => 0,
            'data' => array(),
        );
        $list = DB::table('smtt_happay_cards_transaction')->where('booking_id', $bid)->get();

        foreach ($list as $row){
            if(!isset($return['data'][$row->settlement_id])){
                $return['data'][$row->settlement_id] = array(
                    'fuel' => 0,
                    'toll' => 0,
                );
            }

            if($row->approved_type == 'Toll & Parking'){
                $return['toll'] += $row->amount;
                $return['data'][$row->settlement_id]['toll'] += $row->amount;
            }else if($row->approved_type == 'Fuel'){
                $return['fuel'] += $row->amount;
                $return['data'][$row->settlement_id]['fuel'] += $row->amount;
            }
        }

        return $return;
    }

    public function setProfile(Request $request){
        $request->userid;
        $res = null;

        $customMessages = [
            'regex' => 'This :attribute field formats can be alphabetic and space.'
        ];
        if($request->usertype == 'customer'){
            $res = Customer::find($request->userid);
            if($res->type_client != 'Walk In Customer'){

                $this->validate($request, [
                    'organization_name' => 'required|regex:/^[\pL\s]+$/u',
                    'name' => 'required|regex:/^[\pL\s]+$/u',
                    'phone' => 'required|digits:10',
                    'email' => 'required|email'
                ], $customMessages);

                if (strlen($request->gst_no) > 10) {

                    $gst = Customer::where('gst_no', $request->gst_no)->where('id', '!=', $request->userid)->first();
                    if (isset($gst->id) && $gst->id > 0 && $gst->id != '' && $gst->id != NULL) {
                        return response()->json(['gst_no' => ['Another customer is already exist with this GST no.']], 422);
                    }
                }

                $res->organization_name = $request->organization_name;
                $res->gst_no = $request->gst_no;
                $res->gst_reg_state = $request->gst_reg_state;
                $res->msme = $request->msme;
                $res->pan = $request->pan;
            }else{
                $this->validate($request, [
                    'name' => 'required|regex:/^[\pL\s]+$/u',
                    'phone' => 'required|digits:10',
                    'email' => 'required|email'
                ], $customMessages);
            }
            //"(organization_phone= '{$post['phone']}' OR phone= '{$post['phone']}') and (gst_no is null OR gst_no = '-' OR gst_no = '')";
            $phone = Customer::where(function ($query) use ($request) {
                $query->where('organization_phone',$request->phone)
                    ->orWhere('phone', $request->phone);
            })
                ->where('id','!=',$request->userid)->first();
            if (isset($phone->id) && $phone->id > 0 && $phone->id != '' && $phone->id != NULL) {
                return response()->json(['phone' => ['Another customer is already exist with this Phone.']], 422);
            }

            $res->name = $request->name;
            $res->phone = $request->phone;
            $res->email = $request->email;
            $res->save();

            if($res->isClean()){
                return response()->json(['status' => 'success', 'message' => 'Your profile has been updated successfully.']);
            }else{
                return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
            }
        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function getAccount(Request $request){
        $request->userid;
        $res = null;
        if($request->usertype == 'customer'){
            $info = DB::table('smtt_customers_assistant')->select('name','email', 'phone')->where('type','account')
                ->where('customer_id',
                    $request->userid)->first();
            if(isset($info->name)){
                return response()->json($info);
            }else{
                return response()->json(['name' => '', 'phone' => '', 'email' => '']);
            }

        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function setAccount(Request $request){
        $request->userid;
        $res = null;

        $customMessages = [
            'regex' => 'This :attribute field formats can be alphabetic and space.'
        ];
        if($request->usertype == 'customer'){
            $this->validate($request, [
                'name' => 'required|regex:/^[\pL\s]+$/u',
                'phone' => 'required|digits:10',
                'email' => 'required|email'
            ], $customMessages);

            DB::table('smtt_customers_assistant')
                ->updateOrInsert(
                    ['type' => 'account', 'customer_id' => $request->userid],
                    ['name' => $request->name, 'phone' => $request->phone, 'email' => $request->email ]
                );

            return response()->json(['status' => 'success', 'message' => 'Your account profile has been updated successfully.']);
        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function getBank(Request $request){
        $request->userid;
        $res = null;
        if($request->usertype == 'customer'){
            $info = DB::table('smtt_bank_accounts')->select('name','branch', 'acc_no', 'acc_name', 'ifsc')->where('status','1')
                ->where('type','vendor')
                ->where('type_id', $request->userid)->first();
            if(isset($info->name)){
                return response()->json($info);
            }else{
                return response()->json(['name' => '', 'branch' => '', 'acc_no' => '', 'acc_name' => '', 'ifsc' => '']);
            }

        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function getOurBank(Request $request){
        $info = DB::table('smtt_razorpay_customer')->where('cus_sys_id',$request->userid)->first();
        return response()->json(['data' => $info]);
    }

    public function changePassword(Request $request){
        $this->validate($request, [
            'old_password' => 'required',
            'password' => 'required|confirmed|min:5',
            //'email' => 'required|email'
        ]);
        if($request->usertype == 'customer'){
            $user = DB::table('smtt_customer_setting')->select('password')->where('customer_id', $request->userid)->first();
            //print_r($user);
            //print_r($request);
            if(isset($user->password) && md5($request->old_password) == $user->password ){
                DB::table('smtt_customer_setting')
                    ->where('customer_id', $request->userid)
                    ->update(
                        ['password' => md5($request->password)]
                    );
                return response()->json(['status' => 'success', 'message' => 'Your password has been updated successfully.']);
            }else{
                return response()->json(['old_password' => ['Current password is incorrect.']], 422);
            }
        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    private function getFromCurl($url, $token){
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');


        //curl_setopt($ch, CURLOPT_USERPWD, $this->key . ':' . $this->secret);


        $headers = array();
        $headers[] = 'Content-Type: application/json';
        $headers[] = 'Authorization: '.$token;
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = json_decode( curl_exec($ch),false );
        if (curl_errno($ch)) {
            $result = new stdClass();
            $result->status = false;
            $result->message = 'Error:' . curl_error($ch);
        }

        curl_close($ch);

        return $result;
    }
}
