<?php

namespace App\Http\Controllers;

use App\Authapi;
use App\Customer;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Str;

class UserController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /*protected function buildFailedValidationResponse(Request $request, array $errors) {
        return ["code"=> 201 , "message" => "error" , "errors" =>$errors];
    }*/

    /**
     * Retrieve the user for the given ID.
     *
     * @param  int  $id
     * @return Response
     */
    public function show()
    {
        $user = User::all();
        return response()->json($user);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function authenticate(Request $request)
    {
        //print_r($request->email);exit();
        $this->validate($request, [
            'email' => 'required',
            'password' => 'required'
        ]);
        $user = null;
        if($request->type == 'customer'){
            $user = DB::table('smtt_customer_setting')->where('username', $request->email)->first();
        }else{
            //$user = Users::where('email', $request->input('email'))->first();
        }
        //print_r($user);
        if(isset($user->password) && md5($request->password) == $user->password ){
            $apikey = base64_encode(Str::random(20) . '' . time());
            Authapi::updateOrCreate(
                ['user_id' => $user->customer_id, 'type_db' => $request->type],
                ['api_key' => "$apikey"]);
            return response()->json(['status' => 'success','api_key' => $apikey]);
        }else{
            return response()->json(['status' => 'fail', 'message' => 'Username or password is invalid.'],
                201);
        }
    }

    public function logout(Request $request)
    {
        if($request->has('userid') && $request->has('usertype') ){
            Authapi::where('user_id', $request->userid)->where('type_db', $request->usertype)->delete();
            return response()->json(['status' => 'success']);
        }else{
            return response()->json(['status' => 'fail'],401);
        }
    }

    public function getProfile(Request $request){
        $request->userid;
        $res = null;
        if($request->usertype == 'customer'){
            $res = Customer::find($request->userid);
            $states = DB::table('smtt_package_state')->select('name')->orderBy('name','asc')->get();
            return response()->json(['user' => $res->toArray(), 'states' => $states->toArray()]);
        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function setProfile(Request $request){
        $request->userid;
        $res = null;

        $customMessages = [
            'regex' => 'This :attribute field formats can be alphabetic and space.'
        ];
        if($request->usertype == 'customer'){
            $res = Customer::find($request->userid);
            if($res->type_client != 'Walk In Customer'){

                $this->validate($request, [
                    'organization_name' => 'required|regex:/^[\pL\s]+$/u',
                    'name' => 'required|regex:/^[\pL\s]+$/u',
                    'phone' => 'required|digits:10',
                    'email' => 'required|email'
                ], $customMessages);

                if (strlen($request->gst_no) > 10) {

                    $gst = Customer::where('gst_no', $request->gst_no)->where('id', '!=', $request->userid)->first();
                    if (isset($gst->id) && $gst->id > 0 && $gst->id != '' && $gst->id != NULL) {
                        return response()->json(['gst_no' => ['Another customer is already exist with this GST no.']], 422);
                    }
                }

                $res->organization_name = $request->organization_name;
                $res->gst_no = $request->gst_no;
                $res->gst_reg_state = $request->gst_reg_state;
                $res->msme = $request->msme;
                $res->pan = $request->pan;
            }else{
                $this->validate($request, [
                    'name' => 'required|regex:/^[\pL\s]+$/u',
                    'phone' => 'required|digits:10',
                    'email' => 'required|email'
                ], $customMessages);
            }
            //"(organization_phone= '{$post['phone']}' OR phone= '{$post['phone']}') and (gst_no is null OR gst_no = '-' OR gst_no = '')";
            $phone = Customer::where(function ($query) use ($request) {
                $query->where('organization_phone',$request->phone)
                    ->orWhere('phone', $request->phone);
            })
                ->where('id','!=',$request->userid)->first();
            if (isset($phone->id) && $phone->id > 0 && $phone->id != '' && $phone->id != NULL) {
                return response()->json(['phone' => ['Another customer is already exist with this Phone.']], 422);
            }

            $res->name = $request->name;
            $res->phone = $request->phone;
            $res->email = $request->email;
            $res->save();

            if($res->isClean()){
                return response()->json(['status' => 'success', 'message' => 'Your profile has been updated successfully.']);
            }else{
                return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
            }
        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function getAccount(Request $request){
        $request->userid;
        $res = null;
        if($request->usertype == 'customer'){
            $info = DB::table('smtt_customers_assistant')->select('name','email', 'phone')->where('type','account')
                ->where('customer_id',
                    $request->userid)->first();
            if(isset($info->name)){
                return response()->json($info);
            }else{
                return response()->json(['name' => '', 'phone' => '', 'email' => '']);
            }

        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function setAccount(Request $request){
        $request->userid;
        $res = null;

        $customMessages = [
            'regex' => 'This :attribute field formats can be alphabetic and space.'
        ];
        if($request->usertype == 'customer'){
            $this->validate($request, [
                'name' => 'required|regex:/^[\pL\s]+$/u',
                'phone' => 'required|digits:10',
                'email' => 'required|email'
            ], $customMessages);

            DB::table('smtt_customers_assistant')
                ->updateOrInsert(
                    ['type' => 'account', 'customer_id' => $request->userid],
                    ['name' => $request->name, 'phone' => $request->phone, 'email' => $request->email ]
                );

            return response()->json(['status' => 'success', 'message' => 'Your account profile has been updated successfully.']);
        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function getBank(Request $request){
        $request->userid;
        $res = null;
        if($request->usertype == 'customer'){
            $info = DB::table('smtt_bank_accounts')->select('name','branch', 'acc_no', 'acc_name', 'ifsc')->where('status','1')
                ->where('type','vendor')
                ->where('type_id', $request->userid)->first();
            if(isset($info->name)){
                return response()->json($info);
            }else{
                return response()->json(['name' => '', 'branch' => '', 'acc_no' => '', 'acc_name' => '', 'ifsc' => '']);
            }

        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }

    public function changePassword(Request $request){
        $this->validate($request, [
            'old_password' => 'required',
            'password' => 'required|confirmed|min:5',
            //'email' => 'required|email'
        ]);
        if($request->usertype == 'customer'){
            $user = DB::table('smtt_customer_setting')->select('password')->where('customer_id', $request->userid)->first();
            //print_r($user);
            //print_r($request);
            if(isset($user->password) && md5($request->old_password) == $user->password ){
                DB::table('smtt_customer_setting')
                    ->where('customer_id', $request->userid)
                    ->update(
                        ['password' => md5($request->password)]
                    );
                return response()->json(['status' => 'success', 'message' => 'Your password has been updated successfully.']);
            }else{
                return response()->json(['old_password' => ['Current password is incorrect.']], 422);
            }
        }
        return response()->json(['status' => 'fail', 'message' => 'Something is wrong please try again.']);
    }
}
