<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/

/*$router->get('/', function () use ($router) {
    return $router->app->version();
});*/

$router->post('login', 'UserController@authenticate');

$router->group(['middleware' => 'auth'], function () use ($router) {
    // login
    //$router->get('users', 'UserController@show');
    $router->get('logout', 'UserController@logout');
    // customer section
    $router->get('get_user_profile', 'UserController@getProfile');
    $router->post('set_user_profile', 'UserController@setProfile');
    $router->get('get_user_account', 'UserController@getAccount');
    $router->post('set_user_account', 'UserController@setAccount');
    $router->get('get_user_bank', 'UserController@getBank');
    $router->get('get_our_bank', 'BookingController@getOurBank');
    $router->post('user_change_password', 'UserController@changePassword');
    // Booking section
    //$router->get('booking/get_list', 'BookingController@getList');
    $router->group(['prefix' => 'booking'],function () use ($router) {
        $router->get('get_list', 'BookingController@getList');
        $router->get('get_single', 'BookingController@getSingle');

    });
});
